;-------------------------------------------------------------------------------
;[`
sound_init:
	lda	#$0f
	sta	$4015
	lda	#$00
	sta	channel_sel

	sta	$4080
	sta	$4082
	sta	$4083
	sta	$4084
	sta	$4085
	sta	$4086
	sta	$4087
	sta	$4088
	sta	$4089
	sta	$408a


sound_channel_set:
	lda	channel_sel
	cmp	#$06
	beq	return4

	asl	a
	tax
	lda	#$00
	sta	lfo_st_counter_1,x
	sta	effect_flag,x
	lda	#$01
	sta	sound_counter,x

	lda	sound_data_table,x
	sta	<sound_add_low,x	;f[^Jnʒu
	inx
	lda	sound_data_table,x
	sta	<sound_add_low,x	;f[^Jnʒu
	inc	channel_sel
	jmp	sound_channel_set
return4:
	rts
;-------------------------------------------------------------------------------
sound_channel_reset:
	lda	#$00
	sta	channel_sel
	rts				;łI
;--------------------------
sound_fds_part:
	jsr	sound_fds
	jmp	channel_end
;--------------------------
sound_driver_start:

	lda	channel_sel
	cmp	#$06
	beq	sound_channel_reset	;channel_sel05Ȃ炨I
	cmp	#$05
	beq	sound_fds_part
	cmp	#$04
	beq	sound_dpcm_part

	asl	a
	tax
	dec	sound_counter,x		;JE^炵
	bne	return1			;[ȊOȂJE^炵

	jsr	sound_data_read		;[ȂTEhǂݍ

	lda	rest_flag,x
	and	#%00000001
	cmp	#%00000001
	beq	channel_end		;xȂ炨I

duty_write:
	lda	effect_flag,x
	and	#%00000100
	cmp	#%00000100
	bne	enve_write
	jsr	sound_duty_enverope	;iHjF`

enve_write:
	lda	effect_flag,x
	and	#%00000001
	cmp	#%00000001
	bne	lfo_write
	jsr	sound_software_enverope	;Gx[v`

lfo_write:
	lda	effect_flag,x
	and	#%00010000
	cmp	#%00010000
	bne	pitchenve_write
	jsr	sound_lfo

pitchenve_write:
	lda	effect_flag,x
	and	#%00000010
	cmp	#%00000010
	bne	arpeggio_write
	jsr	sound_pitch_enverope

arpeggio_write:
	lda	effect_flag,x
	and	#%00001000
	cmp	#%00001000
	bne	freq_data_write
	jsr	sound_high_speed_arpeggio
	jmp	channel_end

freq_data_write:
	jsr	sound_data_write	;ăf[^o

channel_end:
	inc	channel_sel		;̃`lݒ肵
	jmp	sound_driver_start	;͂߂ɖ߂

sound_dpcm_part:
	asl	a
	tax
	dec	sound_counter,x		;JE^炵
	bne	channel_end
	jsr	sound_dpcm_play
	jmp	channel_end
;-------
return1:
	lda	rest_flag,x
	and	#%00000001
	cmp	#%00000001
	beq	return7			;xȂ΂

duty_write2:
	lda	effect_flag,x
	and	#%00000100
	cmp	#%00000100
	bne	enve_write2
	jsr	sound_duty_enverope

enve_write2:
	lda	effect_flag,x
	and	#%00000001
	cmp	#%00000001
	bne	lfo_write2
	jsr	sound_software_enverope

lfo_write2:
	lda	effect_flag,x
	and	#%00010000
	cmp	#%00010000
	bne	pitchenve_write2
	jsr	sound_lfo

pitchenve_write2:
	lda	effect_flag,x
	and	#%00000010
	cmp	#%00000010
	bne	arpeggio_write2
	jsr	sound_pitch_enverope

arpeggio_write2:
	lda	effect_flag,x
	and	#%00001000
	cmp	#%00001000
	bne	return7
	jsr	sound_high_speed_arpeggio
	jmp	return7

sound_dpcm_part2:
	jsr	sound_dpcm_play
return7:
	inc	channel_sel		;̃`lݒ肵
	jmp	sound_driver_start	;͂߂ɖ߂
;-------------------------------------------------------------------------------
frequency_set:

	lda	channel_sel
	asl	a
	tax
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#%00001111		;4bito
	asl	a
	tay

	lda	channel_sel
	cmp	#$03
	beq	noise_frequency_get	;S`lڂȂmCYg擾

	lda	psg_frequency_table,y	;PSGge[uLowǂݏo
	sta	sound_freq_low,x	;
	iny				;yP₵
	lda	psg_frequency_table,y	;PSGge[uHighǂݏo
	sta	sound_freq_high,x	;

oct_set1:

	lda	sound_sel,x		;Kf[^ǂݏo
	lsr	a			;4bito
	lsr	a			;
	lsr	a			;
	lsr	a			;
	beq	freq_end		;[Ȃ炻̂܂܏I
	tay				;

oct_set2:

	lsr	sound_freq_high,x	;EVtg@C
	ror	sound_freq_low,x	;C玝Ăł@E[eCg
	dey				;
	bne	oct_set2		;IN^[uJԂ

freq_end:
	lda	effect_flag,x
	and	#%10000000
	cmp	#%10000000
	beq	detune_part
	rts

detune_part:
	lda	detune_dat,x
	and	#%10000000
	cmp	#%10000000
	beq	detune_plus

detune_minus:
	lda	detune_dat,x
	adc	sound_freq_low,x
	sta	sound_freq_low,x
	rts

detune_plus:
	lda	detune_dat,x
	and	#%01111111
	sta	detune_tmp
	lda	sound_freq_low,x
	sbc	detune_tmp
	sta	sound_freq_low,x
	rts

noise_frequency_get:
	lda	noise_frequency_table,y	;ge[uLowǂݏo
	sta	sound_freq_low,x	;
	iny				;yP₵
	lda	noise_frequency_table,y	;ge[uHighǂݏo
	sta	sound_freq_high,x	;
	rts
;-------------------------------------------------------------------------------
sound_data_read:
	jsr	reg400x
	lda	[sound_add_low,x]
;----------
;f[^Ghݒ
	cmp	#$ff
	bne	duty_set

	lda	loop_point_table,x
	sta	<sound_add_low,x	;[vJnʒu Low
	inx
	lda	loop_point_table,x
	sta	<sound_add_low,x	;[vJnʒu High
	jmp	sound_data_read
;----------
;Fݒ
duty_set:
	cmp	#$fe
	bne	volume_set
	jsr	sound_data_address
	lda	[sound_add_low,x]	;Ff[^ǂݏo
	pha
	and	#%10000000		;8bitڊmF
	cmp	#%10000000
	bne	duty_enverope_part	;a[eBGx

duty_select_part:
	lda	effect_flag,x
	and	#%11111011
	sta	effect_flag,x		;f[eBGx[vw
	jsr	reg400x
	pla
	asl	a
	asl	a
	asl	a
	asl	a
	sta	register_high,x		;
	ora	register_low,x
	sta	$4000,y
	jsr	sound_data_address
	jmp	sound_data_read

duty_enverope_part:
	lda	effect_flag,x
	ora	#%00000100
	sta	effect_flag,x		;f[eBGx[vLw
	pla
	sta	duty_sel,x
	asl	a
	tay
	lda	dutyenve_table,y	;f[eBGx[vAhXݒ
	sta	<duty_add_low,x
	iny
	lda	dutyenve_table,y
	sta	<duty_add_high,x
	jsr	sound_data_address
	jmp	sound_data_read

;----------
;ʐݒ
volume_set:
	cmp	#$fd
	bne	rest_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	pha
	and	#%10000000		;8bitڊmF
	cmp	#%10000000
	bne	softenve_part		;\tgGx

volume_part:
	lda	effect_flag,x
	and	#%11111110
	sta	effect_flag,x		;\tgGxw

	pla
	and	#%00001111
	sta	register_low,x
	ora	register_high,x
	sta	$4000,y			;{[
	jsr	sound_data_address
	jmp	sound_data_read

softenve_part:
	lda	effect_flag,x
	ora	#%00000001
	sta	effect_flag,x		;\tgGxLw

	lda	#$00
	sta	register_low,x		;ʏ{[[

	pla
	sta	softenve_sel,x
	asl	a
	tay
	lda	softenve_table,y	;\tgGxf[^AhXݒ
	sta	<soft_add_low,x
	iny
	lda	softenve_table,y
	sta	<soft_add_high,x
	jsr	sound_data_address
	jmp	sound_data_read

;----------
rest_set:
	cmp	#$fc
	bne	lfo_set

	lda	rest_flag,x
	ora	#%00000001
	sta	rest_flag,x

	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x

	lda	channel_sel
	cmp	#$02
	beq	tri

	lda	register_high,x
	sta	$4000,y
	jsr	sound_data_address
	rts
tri:
	lda	#$00
	sta	$4000,y
	jsr	sound_data_address
	rts
;----------
lfo_set:
	cmp	#$fb
	bne	detune_set

	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	lfo_data_set

	jsr	reg400x
	lda	effect_flag,x
	and	#%10001111		;LFO
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_data_read

lfo_data_set:
	asl	a
	asl	a
	tay

	lda	channel_sel
	asl	a
	tax

	lda	lfo_data,y
	sta	lfo_st_counter_1,x
	sta	lfo_st_counter_2,x	;LFOJn܂ł̃JE^Zbg
	iny
	lda	lfo_data,y
	sta	lfo_move,x		;LFOœʃZbg
	iny
	lda	lfo_data,y
	sta	lfo_revers,x		;g`]܂ł̓񐔃Zbg
	inc	lfo_revers,x
	iny
	lda	effect_flag,x
	and	#%10001111
	ora	#%00010000		;LFOLtOZbg
	ora	lfo_data,y		;LFOJntOZbg
	sta	effect_flag,x

	jsr	sound_data_address
	jmp	sound_data_read
;----------
detune_set:
	cmp	#$fa
	bne	sweep_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	detune_data_set

	jsr	reg400x
	lda	effect_flag,x
	and	#%01111111		;detune
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_data_read

detune_data_set:
	pha
	jsr	reg400x
	pla
	tay
	sta	detune_dat,x
	lda	effect_flag,x
	ora	#%10000000		;detuneL
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_data_read

;----------
sweep_set:
	cmp	#$f9
	bne	pitch_set

	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	$4001,y
	jsr	sound_data_address
	jmp	sound_data_read
;----------
;sb`Gx[vݒ
pitch_set:
	cmp	#$f8
	bne	arpeggio_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	pitch_enverope_part

	lda	effect_flag,x
	and	#%11111101
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_data_read

pitch_enverope_part:
	sta	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_table,y
	sta	<pitch_add_low,x
	iny
	lda	pitchenve_table,y
	sta	<pitch_add_high,x

	lda	effect_flag,x
	ora	#%00000010
	sta	effect_flag,x

	jsr	sound_data_address
	jmp	sound_data_read

;----------
;m[gGx[vݒ
arpeggio_set:
	cmp	#$f7
	bne	freq_direct_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	arpeggio_part

	lda	effect_flag,x
	and	#%11110111
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_data_read

arpeggio_part:
	sta	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_table,y
	sta	<arpe_add_low,x
	iny
	lda	arpeggio_table,y
	sta	<arpe_add_high,x

	lda	effect_flag,x
	ora	#%00001000
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_data_read
;----------
;Đgڐݒ
freq_direct_set:
	cmp	#$f6
	bne	y_command_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_freq_low,x		;Low
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_freq_high,x		;High
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x			;Counter
	jsr	sound_data_address
	jsr	effect_init
	rts
;----------
;R}hݒ
y_command_set:
	cmp	#$f5
	bne	wait_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	<reg_add_low
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	<reg_add_high
	jsr	sound_data_address
	lda	[sound_add_low,x]
	ldx	#$00
	sta	[reg_add_low,x]
	jsr	reg400x
	jsr	sound_data_address
	jmp	sound_data_read
;----------
;EFCgݒ
wait_set:
	cmp	#$f4
	bne	oto_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x
	jsr	sound_data_address
	rts
;----------
oto_set:
	sta	sound_sel,x		;͂܂
	jsr	sound_data_address
	lda	[sound_add_low,x]	;ǂݏo
	sta	sound_counter,x		;ۂ̃JEglƂȂ܂
	jsr	sound_data_address
	jsr	frequency_set		;gZbg
	jsr	effect_init
	rts
;-----------------
sound_data_address:
	inc	<sound_add_low,x	;f[^AhX{P
	bne	return2			;ʂオ
	inc	<sound_add_high,x	;f[^AhXS̈ʁij{P
return2:
	rts
;-------------------------------------------------------------------------------
sound_data_write:
	jsr	reg400x
	lda	register_low,x		;ʕێ
	ora	register_high,x
	sta	$4000,y
write:
	lda	sound_freq_low,x	;Low Write
	sta	$4002,y
	lda	sound_freq_high,x	;High Write
	sta	$4003,y
	rts
;-------------------------------------------------------------------------------
sound_software_enverope:
	jsr	reg400x

	lda	[soft_add_low,x]	;Gx[vf[^ǂݍ
	cmp	#$ff			;Ōォǁ[
	beq	return3			;ŌȂ烋[v

	sta	register_low,x
	ora	register_high,x		;Ff[^i4bitjƉ4bitőZ
	sta	$4000,y			;݁`
	jsr	enverope_address	;AhX₵
	rts				;܂
return3:
	lda	softenve_sel,x
	asl	a
	tay
	lda	softenve_lp_table,y
	sta	<soft_add_low,x
	iny
	lda	softenve_lp_table,y
	sta	<soft_add_high,x
	jmp	sound_software_enverope

;-------------------------------------------------------------------------------
enverope_address:
	inc	<soft_add_low,x
	bne	return5
	inc	<soft_add_high,x
return5:
	rts
;--------------------------------------	
reg400x:
	lda	channel_sel
	asl	a
	tax
	asl	a
	tay
	rts
;-------------------------------------------------------------------------------
sound_duty_enverope:
	jsr	reg400x

	lda	channel_sel
	cmp	#$02
	beq	return21		;OpgȂ΂`

	lda	[duty_add_low,x]	;Gx[vf[^ǂݍ
	cmp	#$ff			;Ōォǁ[
	beq	return22		;ŌȂ炻̂܂܂܂
	asl	a
	asl	a
	asl	a
	asl	a
	sta	register_high,x
	ora	register_low,x		;Ff[^i4bitjƉ4bitőZ
	sta	$4000,y			;݁`
	jsr	duty_enverope_address	;AhX₵
return21:
	rts				;܂

return22:
	lda	duty_sel,x
	asl	a
	tay
	lda	dutyenve_lp_table,y
	sta	<duty_add_low,x
	iny
	lda	dutyenve_lp_table,y
	sta	<duty_add_high,x
	jmp	sound_duty_enverope

;-------------------------------------------------------------------------------
duty_enverope_address:
	inc	<duty_add_low,x
	bne	return23
	inc	<duty_add_high,x
return23:
	rts
;--------------------------------------	
sound_dpcm_play:
	jsr	reg400x
	lda	[sound_add_low,x]
;----------
	cmp	#$ff
	bne	no_dpcm
	lda	loop_point_table,x
	sta	<sound_add_low,x
	inx
	lda	loop_point_table,x
	sta	<sound_add_low,x
	jmp	sound_dpcm_play
;----------
no_dpcm:
	cmp	#$fc
	bne	wait_set2
	lda	#$00
	sta	$4011
	jmp	ontyou2

wait_set2:
	cmp	#$f4
	bne	dpcm_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x
	jsr	sound_data_address
	rts

dpcm_set:
	asl	a
	asl	a
	tax

	pha
	lda	#$0F
	sta	$4015
	pla

	lda	dpcm_data,x		;DPCM control
	sta	$4010
	inx	
	lda	dpcm_data,x		;DPCM wave control
	sta	$4011
	inx	
	lda	dpcm_data,x		;DPCM address set
	sta	$4012
	inx	
	lda	dpcm_data,x		;DPCM length set
	sta	$4013

	lda	#$1F
	sta	$4015

ontyou2:
	jsr	reg400x
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x
	jsr	sound_data_address
	rts
;-------------------------------------------------------------------------------
sound_lfo:
	jsr	reg400x
	dec	lfo_st_counter_2,x
	bne	lfo_end

	inc	lfo_st_counter_2,x

	lda	lfo_counter,x
	cmp	lfo_revers,x
	bne	tsuduki			;@@ALFOύXJE^ >= g`]܂ł̓񐔁@ȂA

	lda	#$00
	sta	lfo_counter,x		;@@@@LFOύXJE^ = - g`]܂ł̓
	lda	effect_flag,x
	and	#%00100000
	cmp	#%00100000
	beq	jousyou			;@@@@ALFOtO = ~ȂA

kakou:
	lda	effect_flag,x
	adc	#$20
	sta	effect_flag,x		;@@@@@@LFOtO = ~
	jmp	tsuduki

jousyou:
	lda	effect_flag,x		;@@@@łȂȂiLFOtO = ~jȂA
	sbc	#$20
	sta	effect_flag,x		;@@@@@@LFOtO = ㏸


tsuduki:
	lda	effect_flag,x		;   LFOtO = ~ Ȃ
	and	#%00100000
	cmp	#%00100000
	beq	MINUS
					;ݐϒl = ݐϒl + P񂲂Ƃɑl
					;݂̒l = Kigj + ݐϒl
					;݂̒l = Kigj + (ݐϒl >> 4)
PLUS:
	lda	sound_freq_low,x
	adc	lfo_move,x
	sta	sound_freq_low,x	;    ݂̒l = ݂̒l - œl
	jmp	tsuduki2
MINUS:
	lda	sound_freq_low,x	;  łȂȂiLFOtO = ㏸łȂj
	sbc	lfo_move,x
	sta	sound_freq_low,x	;    ݂̒l = ݂̒l + œl
					;܂ŁB
tsuduki2:
	inc	lfo_counter,x		;	@@LFOύXJE^ = LFOύXJE^ + 1
	jsr	reg400x
	lda	sound_freq_low,x
	sta	$4002,y			;@@ݒlWX^ɃZbg
lfo_end:
	rts				;܂
;-------------------------------------------------------------------------------
sound_pitch_enverope:
	jsr	reg400x
	lda	[pitch_add_low,x]
	cmp	#$ff
	beq	return62

	and	#%10000000
	cmp	#%10000000
	beq	pitch_plus

	lda	[pitch_add_low,x]
	clc
	adc	sound_freq_low,x
	sta	sound_freq_low,x
	jmp	pitch_write

pitch_plus:
	lda	[pitch_add_low,x]
	and	#%01111111
	sta	pitch_tmp
	clc
	lda	sound_freq_low,x
	sbc	pitch_tmp
	sta	sound_freq_low,x

pitch_write:
	lda	sound_freq_low,x
	sta	$4002,y
	jsr	pitch_enverope_address
	rts

return62:
	lda	[pitch_add_low,x]
	lda	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_lp_table,y
	sta	<pitch_add_low,x
	iny
	lda	pitchenve_lp_table,y
	sta	<pitch_add_high,x
	jmp	sound_pitch_enverope
;-------------------------------------------------------------------------------
pitch_enverope_address:
	inc	<pitch_add_low,x
	bne	return63
	inc	<pitch_add_high,x
return63:
	rts
;-------------------------------------------------------------------------------
sound_high_speed_arpeggio:		;note enverope
	jsr	reg400x
	lda	[arpe_add_low,x]	;m[gGxf[^ǂݏo
	cmp	#$ff			;$ffiIjH
	bne	tsuduki99		;łȂΑ
	jmp	return82		;$ffȂ烋[v|Cg֖߂

tsuduki99
	cmp	$00			;[H
	beq	note_freq_write		;[Ȃ牽I
	cmp	$80
	beq	note_freq_write		;[Ȃ牽I
	and	#%10000000
	cmp	#%10000000		;|H
	beq	arpeggio_minus		;|

arpeggio_plus:
	lda	[arpe_add_low,x]	;m[gGxf[^ǂݏo
	sta	arpeggio_tmp		;e|ɒui[v񐔁j
arpeggio_plus2:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$0f			;4bito
	cmp	#$0b			;bȂ
	beq	oct_plus		;IN^[u{
	inc	sound_sel,x		;łȂΉK{P
	jmp	loop_1			;[vP
oct_plus:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$f0			;4bito4bit[
	clc
	adc	#$10			;IN^[u{P
	sta	sound_sel,x		;Kf[^o
loop_1:
	dec	arpeggio_tmp		;[v񐔁|P
	lda	arpeggio_tmp		;œǂݏo
	cmp	#$00			;[H
	beq	note_freq_set		;Ȃ烋[vI
	jmp	arpeggio_plus2		;łȂ΂܂

arpeggio_minus:
	lda	[arpe_add_low,x]
	and	#%01111111
	sta	arpeggio_tmp
arpeggio_minus2:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$0f			;4bito
	cmp	#$00			;[H
	beq	oct_minus		;[Ȃ|
	dec	sound_sel,x		;łȂΉK|P
	jmp	loop_2			;[vQ
oct_minus:
	lda	sound_sel,x		;Kf[^ǂݏo
	adc	#$0b			;+b
	sbc	#$10			;-10
	sta	sound_sel,x		;Kf[^o
loop_2:
	dec	arpeggio_tmp		;[v񐔁|P
	lda	arpeggio_tmp		;œǂݏo
	cmp	#$00			;[H
	beq	note_freq_set		;Ȃ烋[vI
	jmp	arpeggio_minus2		;łȂ΂܂

note_freq_set:
	jsr	frequency_set
note_freq_write:
	jsr	reg400x
	lda	sound_freq_low,x
	sta	$4002,y
	lda	sound_freq_high,x
	sta	$4003,y
	jsr	arpeggio_address
	rts

return82:
	lda	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_lp_table,y
	sta	<arpe_add_low,x
	iny
	lda	arpeggio_lp_table,y
	sta	<arpe_add_high,x
	jmp	sound_high_speed_arpeggio
;-------------------------------------------------------------------------------
arpeggio_address:
	inc	<arpe_add_low,x
	bne	return83
	inc	<arpe_add_high,x
return83:
	rts
;-------------------------------------------------------------------------------
effect_init:
;\tgEFAGx[vǂݍ݃AhX
	lda	softenve_sel,x
	asl	a
	tay
	lda	softenve_table,y
	sta	<soft_add_low,x
	iny
	lda	softenve_table,y
	sta	<soft_add_high,x

;sb`Gx[vǂݍ݃AhX
	lda	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_table,y
	sta	<pitch_add_low,x
	iny
	lda	pitchenve_table,y
	sta	<pitch_add_high,x

;f[eBGx[vǂݍ݃AhX
	lda	duty_sel,x
	asl	a
	tay
	lda	dutyenve_table,y
	sta	<duty_add_low,x
	iny
	lda	dutyenve_table,y
	sta	<duty_add_high,x

;m[gGx[vǂݍ݃AhX
	lda	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_table,y
	sta	<arpe_add_low,x
	iny
	lda	arpeggio_table,y
	sta	<arpe_add_high,x
;\tgEFALFO
	lda	lfo_st_counter_1,x	;LFOJnJE^Zbg
	sta	lfo_st_counter_2,x

	lda	effect_flag,x		;LFOJnZbg
	and	#%11011111
	sta	effect_flag,x
	and	#%01000000
	lsr	a
	ora	effect_flag,x
	sta	effect_flag,x
	lda	lfo_revers,x
	lsr	a
	sta	lfo_counter,x		;LFOύXJE^Zbg

;xtONA
	lda	#$00
	sta	rest_flag,x

	jsr	reg400x
	rts
;-------------------------------------------------------------------------------
;[y[WɕKvȃ
;6ch sq1 sq2 tri noiz dpcm fds
soft_add_low	=	$00c0	;6bytes $c0,$c1 ch1 - $ca,$cb ch6 *ch5͖gp
soft_add_high	=	$00c1	;6bytes
pitch_add_low	=	$00d0	;8bytes $d0,$d1 ch1 - $da,$db ch6 *ch4-5͖gp
pitch_add_high	=	$00d1	;8bytes
duty_add_low	=	$00b0	;4bytes $e6,$e7 ch1 - $e8,$e9 ch2 *ch3-6͖gp
duty_add_high	=	$00b1	;4bytes
arpe_add_low	=	$00e0	;6bytes $e0,$e1 ch1 - $ea,$eb ch6 *ch4-5͖gp
arpe_add_high	=	$00e1	;6bytes
sound_add_low	=	$00f0	;6bytes $f0,$f1 ch1 - $fa,$fb ch6
sound_add_high	=	$00f1	;6bytes

reg_add_low	=	$00fe	;temp
reg_add_high	=	$00ff
fds_wave_address=	$00fe
fds_wave_addhigh=	$00ff

;ȊOɕKvȃ

lfo_revers	=	$0700	;6bytes(12	g`]܂ł̉
lfo_move	=	$0701	;6bytes(12	œ
lfo_counter	=	$070c	;6bytes(6	LFOJE^
lfo_st_counter_1=	$070d	;6bytes(6	LFOJn܂ł̃JE^iێp
lfo_st_counter_2=	$0718	;6bytes(6	LFOJn܂ł̃JE^
detune_dat	=	$0719	;6bytes(6
register_high	=	$0724	;2bytes(8
register_low	=	$0725	;2bytes(8

softenve_sel	=	$0730	;6bytes(12
pitch_sel	=	$0731	;6bytes(12
arpeggio_sel	=	$0740	;6bytes(12
effect_flag	=	$0741	;6bytes(12
duty_sel	=	$074c	;2bytes(4

rest_flag	=	$0750	;6bytes(12
detune_tmp	=	$0751	;1byte
pitch_tmp	=	$0753	;1byte
arpeggio_tmp	=	$0755	;1byte
temporary	=	$0757	;1byte
channel_sel	=	$0759	;1byte
fds_hard_count_1=	$075b
fds_hard_count_2=	$075c
fds_408a_temp	=	$075d

sound_sel	=	$0760	;6bytes(12
sound_counter	=	$0761	;6bytes(12
sound_freq_low	=	$0770	;6bytes
sound_freq_high	=	$0771	;6bytes
;fds_effect	=	$077e
fds_volume	=	$077f

;+------ detune flag
;l+----- software LFOtOێp(0=- 1=+)$40
;ll+---- software LFOtO
;lll+--- software LFO flag
;llll+---- note enverope flag
;lllll+--- duty enverope flag / FDS hardware effect flag
;llllll+-- pitch enverope flag
;lllllll+- software enverope flag
;llllllll
;DLLLadpv
